<template>
    <div class="edit-popup">
        <popup ref="popupRef" :title="popupTitle" :async="true" width="550px" @confirm="handleSubmit" @close="handleClose">
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="单位名称" prop="name">
                    <el-input v-model="formData.name" clearable placeholder="请输入单位名称" />
                </el-form-item>
                <!-- <el-form-item label="拼音信息" prop="py">
                    <el-input v-model="formData.py" clearable placeholder="请输入拼音信息" />
                </el-form-item> -->
                <el-form-item label="单位编号" prop="number">
                    <el-input v-model="formData.number" clearable placeholder="请输入单位编号" />
                </el-form-item>
                <el-form-item label="是否散装" prop="is_bulk">
                    <el-radio-group v-model="formData.is_bulk">
                        <el-radio :label="1">是</el-radio>
                        <el-radio :label="0">否</el-radio>
                    </el-radio-group>
                </el-form-item>
                <el-form-item label="备注信息" prop="data">
                    <el-input v-model="formData.data" type="textarea" clearable placeholder="请输入备注信息" />
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="unitEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiStoreProductUnitAdd, apiStoreProductUnitEdit, apiStoreProductUnitDetail } from '@/api/store_product_unit'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑计量单位' : '新增计量单位'
})

// 表单数据
const formData = reactive({
    id: '',
    name: '',
    py: '',
    number: '',
    data: '',
    is_bulk: 0,
})


// 表单验证
const formRules = reactive<any>({
    name: [{
        required: true,
        message: '请输入单位名称',
        trigger: ['blur']
    }]
})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }


}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiStoreProductUnitDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData, }
    mode.value == 'edit'
        ? await apiStoreProductUnitEdit(data)
        : await apiStoreProductUnitAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
